{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
{% endblock begin_javascript_fix %}



{% block begin_javascript %}
{{ parent() }}
    {{ modulename }}Obj.prototype = {
        renderDefaulUI : false,
        windowButtons : {
            add: true,
            delete: true,
            edit: false,
            exit: true,
            formSubmit: true,
            formCancel: true
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);

            t.initDefaultButtons();

            t.layout = new mj.layout({
                renderTo : t.win.getBody(),
                layout : 'border',
                items : [
                    {
                        region  : 'west',
                        size : 250,
                        split: true,
                        collapsible : false
                    }
                ]
            });

            var menuTreeCnt = $(mj.NE(t.layout.getBody('west'), {style:'overflow-y:auto;width:100%;height:100%;'}));

            t.menuTree = new mj.tree({
                renderTo : menuTreeCnt,
                expanded : true,
                mode : 'local',
                entity : t.modulename,
                store : t.stores.main
            });

            t.menuTree.on('select', function(nodeData, eventData, e){
                t.buttons.delete.enable();
                t.forms.main.setValue(nodeData);
                t.activateTabForm();
            });
            var _prep = function(val){ return typeof val == 'undefined' || val == '#' ? 0 : parseInt(val); };
            t.menuTree.on('move_node', function(node){
                var data = { id: node.node.original.id, v: node.node.original.version, newParentId: _prep(node.parent), newOrder: _prep(node.position), oldParentId: _prep(node.old_parent), oldOrder: _prep(node.old_positin)};

                t.win.mask.show();
                var routeName = t.modulename+'-order';
                var route = Routing.getRoute(routeName);
                var url = Routing.generate(routeName, data);
                if(route && route.methods && route.methods.length>0 && route.methods[0]){
                    $.ajax({
                        url: url,
                        method: route.methods[0],
                        data: JSON.stringify(data),
                        contentType: 'application/json',
                        dataType: 'json',
                        success: function(data, textStatus, jqXHR){
                            t.reset(data);
                        },
                        error: function(jqXHR, textStatus, errorThrown){
                            mj.message({title: mj.lng.glb.error, text: jqXHR.responseJSON.message, type: "error", html: true});
                        },
                        complete: function(jqXHR, textStatus){
                            t.win.mask.hide();
                        }
                    });
                }
            });
            var onDeselect = function(){
                t.tabs.main.hint.activate();
                t.forms.main.clear();

                t.buttons.formCancel.hide();
                t.buttons.formSubmit.hide();

                t.buttons.delete.disable();
            };
            t.menuTree.on('deselect', onDeselect);
            t.menuTree.on('deselect_all', onDeselect);

            t.tabPanels = {};
            t.tabPanels.main = new mj.tab({
                renderTo: t.layout.getBody('center'),
                activeTab: 0,
                border: false,
                hideHeader: true,
                items: [
                    {
                        closable: false
                    }, {
                        closable: false
                    }
                ]
            });
            t.tabs = {};
            t.tabs.main = {
                hint: t.tabPanels.main.tabs[0],
                form: t.tabPanels.main.tabs[1]
            };
            t.on('activate-tab-hint', t._onActivateTabHint);
            t.on('activate-tab-form', t._onActivateTabForm);

            var hintCnt = t.tabs.main.hint.getBody();
            hintCnt.css('display', 'table');
            mj.NE(hintCnt, {style:'display:table-cell;vertical-align:middle;align:center;', html:"{{ 'Menu.selectRecordToEdit'|trans }}"});

            t.forms = {};
            t.forms.main = new mj.form({
                renderTo: t.tabs.main.form.getBody(),
                modulename: t.modulename,
                mask: t.win.mask,
                menuTree: t.menuTree,
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.numberField({
                        dataIndex: 'parentid',
                        hidden: true
                    }),
                    new mj.form.textField({
                        title: "{{ 'Menu.menuId'|trans }}",
                        dataIndex: 'menuId',
                        grid: 's4'
                    }),
                    new mj.form.textField({
                        title: "{{ 'Menu.modulename'|trans }}",
                        dataIndex: 'modulename',
                        grid: 's4'
                    }),
                    new mj.form.textField({
                        title: "{{ 'Menu.titleField'|trans }}",
                        dataIndex: 'title',
                        grid: 's4'
                    }),
                    new mj.form.textField({
                        title: "{{ 'Menu.url'|trans }}",
                        dataIndex: 'url',
                        grid: 's12'
                    }),
                    new mj.form.numberField({
                        title: "{{ 'Menu.width'|trans }}",
                        dataIndex: 'width',
                        grid: 's6'
                    }),
                    new mj.form.numberField({
                        title: "{{ 'Menu.height'|trans }}",
                        dataIndex: 'height',
                        grid: 's6'
                    }),
                    new mj.form.textField({
                        title: "{{ 'Menu.cls'|trans }}",
                        dataIndex: 'cls',
                        grid: 's6'
                    }),
                    new mj.form.textField({
                        title: "{{ 'Menu.iconcls'|trans }}",
                        dataIndex: 'iconcls',
                        grid: 's6'
                    }),
                    new mj.form.textArea({
                        title: "{{ 'Menu.script'|trans }}",
                        dataIndex: 'script',
                        grid: 's12'
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'Menu.maximizable'|trans }}",
                        dataIndex: 'maximizable',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        grid: 'none'
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'Menu.multiplewindow'|trans }}",
                        dataIndex: 'multiplewindow',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        grid: 'none'
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'Menu.resizable'|trans }}",
                        dataIndex: 'resizable',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        grid: 'none'
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'Menu.mobiledevice'|trans }}",
                        dataIndex: 'mobiledevice',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        grid: 'none'
                    })
                ]
            });

            t.on('beforesave', function(){
                var f = this.forms.main;
                var id = f.getValue('id').id;
                if(!id && f.menuTree.selected && f.menuTree.selected.node.original){
                    f.setValue({'parentid': f.menuTree.selected.node.original.id});
                }
            });
            t.on('reset', function(_forms, _data){
                t.menuTree.clearSelection();
                t.tabs.main.hint.activate();
                if(typeof _data !== 'undefined'){
                    t.menuTree.store.data = _data;
                }
                t.menuTree.store.load();
            });
        },
        _onActivateTabForm: function() {
            this.buttons.formCancel.show();
            this.buttons.formSubmit.show();
        },
        _onActivateTabHint: function() {
            this.buttons.formCancel.hide();
            this.buttons.formSubmit.hide();
        },
        _onButtonFormCancelClick: function() {
            this.reset();
            this.activateTabHint();
        },
        activateTabForm: function() {
            this.tabs.main.form.activate();
            this.trigger('activate-tab-form');
        },
        activateTabGrid: function() {
            this.activateTabHint();
        },
        activateTabHint : function(){
            this.tabs.main.hint.activate();
            this.trigger('activate-tab-hint');
        },
        getSelectedRecord : function(){
            return (this.menuTree.selected && this.menuTree.selected.node.original) ? this.menuTree.selected.node.original : false;
        },
        initDefaultButtons : function(){
            {{ modulename }}Obj.superclass.initDefaultButtons.call(this);
        }
    };
{% endblock begin_javascript %}



{% block begin_default_module %}
{{ parent() }}
{% endblock begin_default_module %}



{% block end_default_module %}
{{ parent() }}
{% endblock end_default_module %}


{% block end_javascript %}
{{ parent() }}
{% endblock end_javascript %}


{% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
{{ parent() }}
{% endblock body %}
